<template>
    <div class="timer" :style="timerStyle" @click="resetTimer">
      <div class="timer__progress" :style="progressStyle"></div>
      <p class="timer__label">{{ formatTime(remainingPromoTime) }}</p>
    </div>
</template>

<script>
import { mapGetters } from 'vuex';

export default {
  name: 'PromoTimer',
  props: {
    designType: {
      type: String,
      default: 'PlanetLearn'
    }, 
    maxTime: {
      type: Number,
      default: 180
    }
  },
  data(){
    return {
      timer: null,
    }
  },
  computed: {
    ...mapGetters({
      remainingPromoTime: 'ABTest/getPromoTime', 
    }),
    timerStyle() {
      return this.remainingPromoTime < 10 ? 'box-shadow: 0px 0px 6px 0px rgba(255, 0, 0, 0.80)' : '';

    },
    progressStyle() {
      const progressWidth = `${(this.remainingPromoTime / this.maxTime) * 100}%`;
      return {
        width: progressWidth,
        backgroundColor: this.designType === 'PlanetLearn' ? '#00CA14': '#4EAAFF',
      };
    },
  },
  mounted() {
    this.startTimer();
  },
  beforeDestroy() {
    clearInterval(this.timer);
  },
  methods: {
    resetTimer(){
      this.$store.commit('ABTest/setPromoTime', 180);
      this.startTimer();
    },
    formatTime(seconds) {
      const minutes = Math.floor(seconds / 60);
      const remainingSeconds = seconds % 60;
      return `${minutes.toString().padStart(2, '0')}:${remainingSeconds.toString().padStart(2, '0')}`;
    },
    startTimer() {
      this.timer = setInterval(() => {
        if (this.remainingPromoTime > 0) {
          document.cookie = `PromoTimer=${this.remainingPromoTime - 1}`;
          this.$store.commit('ABTest/setPromoTime', this.remainingPromoTime - 1);
        } else {
          clearInterval(this.timer);
        }
      }, 1000);
    },
  },
};
</script>

<style lang="scss" scoped>
.timer {
  background-color: black;
  border-radius: 12px;
  position: relative;
  display: flex;
  align-items: center;
  overflow: hidden;
  width: 110px;
  height: 47px;
  @media screen and (min-width: 768px) {
    height: 60px;
    width: 160px;
  }
}

.timer__progress {
  height: 100%;
  border-radius: 12px;
  transition: width 1s linear;
}

.timer__label {
  color: white;
  position: absolute;
  top: 50%;
  left: 50%;
  transform: translate(-50%, -50%);
  z-index: 2;
  color: #fff;
  text-align: center;
  font-family: Proxima Nova;
  font-size: 24px;
  font-style: normal;
  font-weight: 600;
  margin: 0;
}
</style>